Codeforces Round #396 (Div. 2) E. Mahmoud and a xor trip dfs 按位考虑

E. Mahmoud and a xor trip

题目连接:

http://codeforces.com/contest/766/problem/E

Description

Mahmoud and Ehab live in a country with n cities numbered from 1 to n and connected by n - 1 undirected roads. It’s guaranteed that you can reach any city from any other using these roads. Each city has a number ai attached to it.

We define the distance from city x to city y as the xor of numbers attached to the cities on the path from x to y (including both x and y). In other words if values attached to the cities on the path from x to y form an array p of length l then the distance between them is , where is bitwise xor operation.

Mahmoud and Ehab want to choose two cities and make a journey from one to another. The index of the start city is always less than or equal to the index of the finish city (they may start and finish in the same city and in this case the distance equals the number attached to that city). They can’t determine the two cities so they try every city as a start and every city with greater index as a finish. They want to know the total distance between all pairs of cities.

Input

The first line contains integer n (1 ≤ n ≤ 105) — the number of cities in Mahmoud and Ehab’s country.

Then the second line contains n integers a1, a2, …, an (0 ≤ ai ≤ 106) which represent the numbers attached to the cities. Integer ai is attached to the city i.

Each of the next n  -  1 lines contains two integers u and v (1  ≤  u,  v  ≤  n, u  ≠  v), denoting that there is an undirected road between cities u and v. It’s guaranteed that you can reach any city from any other using these roads.

Output

Output one number denoting the total distance between all pairs of cities.

Sample Input

3
1 2 3
1 2
2 3

Sample Output

10

Hint

题意

给你一棵树,点权,让你输出所有路径的异或和的和。

题解:

因为是点权,和边权不一样的是要考虑LCA的影响,所以我们这样做:

异或我们把数的二进制每一位单独拿出来考虑就好了。

dfs考虑每一个点作为LCA的答案是多少,不停走下去就好了,记录下0和1的数量。

我也不知道怎么说才好,还是看代码吧= =

代码

#include<bits/stdc++.h>
using namespace std;
const int maxn = 1e5+7;
int n;
long long a[maxn],sum1,res,num[maxn][2];
vector<int> E[maxn];
void dfs(int x,int f,int bit){
    int t=a[x]>>bit&1;
    num[x][t]=1,num[x][t^1]=0;
    long long s=0;
    for(int i=0;i<E[x].size();i++){
        int v = E[x][i];
        if(v==f)continue;
        dfs(v,x,bit);
        s+=num[x][0]*num[v][1]+num[x][1]*num[v][0];
        num[x][t^0]+=num[v][0];
        num[x][t^1]+=num[v][1];
    }
    res+=s<<bit;
}
int main()
{
    scanf("%d",&n);
    for(int i=1;i<=n;i++)
        scanf("%lld",&a[i]),sum1+=a[i];
    for(int i=1;i<n;i++){
        int x,y;
        scanf("%d%d",&x,&y);
        E[x].push_back(y);
        E[y].push_back(x);
    }
    for(int i=0;i<30;i++)
        dfs(1,0,i);
    cout<<res+sum1<<endl;
}
    原文作者:qscqesze
    原文地址: https://www.cnblogs.com/qscqesze/p/6378392.html
    本文转自网络文章,转载此文章仅为分享知识,如有侵权,请联系博主进行删除。
点赞